#include <stdinc.h>
#include <nuc.h>
#include <weight.h>
#include <loopen.h>
#include <score.h>
#include <extfunc.h>

#define MAX_SEQ 6000
#define MAX_REALSTACK 50
#define MAX_STACK 3500

#define ITERTIMES 200
#define MAX_LOOP 100

char inpfile[100], outfile[100];
double min_perc;
int  num_seeds;
int  min_hb, min_sl;
int  min_hb2, min_sl2;
int  min_hb3, min_sl3;
int  idum;
int  maxgap;
double weight1, weight2, weight3;
int GAPST, GAPET;
int bandsize;
char gurem;
int min_loop_len, min_all_loop_len;

void initenv(int argc, char **argv);

main(int argc, char **argv)
{
	int	i, j, k, l, m, n, p, q;
	int	*numcov;
	int	**stacks, **predstacks, **predstacks_fin;
	int	*num_stacks, *num_predstacks;
	int	*len_seq, num_seq;
	int	*predstacks_tmp1, num_predstacks_tmp1, *predstacks_tmp2, num_predstacks_tmp2;
	double	*score_tmp1, *score_tmp2, **score_fin;
	int	*index;
	int	*loops, *len_loops, **looppos, num_loop, *num_pos;
	MATCH	match_stacks, *mstacks, *min_mstacks, *min_2mstacks;
	int	tot_num, tot_tru;
	double	**score;
	char	**seq, **seqname, **partialseq;
	int	num_pair;
	int	indexi;
	double	min_mscore, mscore, ss;
	BPUPOS	*bpupos;
	FILE	*fp;

	idum = 10;
	random1(&idum);
	initenv(argc, argv);

	fp = ckopen("loop", "r");
	readloopen(fp);
	fclose(fp);

	len_seq = (int *) ckalloc(MAX_SEQ * sizeof(int));
	seq = (char **) ckalloc(MAX_SEQ * sizeof(char *));
	seqname = (char **) ckalloc(MAX_SEQ * sizeof(char *));
	for(i = 0; i < MAX_SEQ; i ++)	{
		seqname[i] = (char *) ckalloc(100 * sizeof(char));
	}
	fp = ckopen(inpfile, "r");
	num_seq = readseq1by1(seq, seqname, len_seq, fp);
	fclose(fp);
printf("num_seq = %d\n", num_seq);

	num_predstacks = (int *) ckalloc(num_seq * sizeof(int));
	predstacks = (int **) ckalloc(num_seq * sizeof(int *));
	for(i = 0; i < num_seq; i ++)	{
		predstacks[i] = (int *) ckalloc(4 * MAX_STACK * sizeof(int));
	}

	if(num_seq == 1)	{
		printf("Input must be more than 1 sequence\n");
		exit(-1);
	}

/*	Sort predicted stacks according to their header	*/

	score = (double **) ckalloc(num_seq * sizeof(double *));
	for(i = 0; i < num_seq; i ++)	{
		num_predstacks[i] = predict_stack(seq[i], len_seq[i], predstacks[i], maxgap, min_hb, min_sl);
		printf("%d # stacks: %d\n", i, num_predstacks[i]);
		for(j = 0; j < 4 * num_predstacks[i]; j ++)	{
			predstacks[i][j] ++;
		}
		sortbpu(predstacks[i], num_predstacks[i]);
		score[i] = (double *) ckalloc(num_predstacks[i] * sizeof(double));
		for(j = 0; j < num_predstacks[i]; j ++)	{
			score[i][j] = compu_score(seq[i], len_seq[i], &predstacks[i][4 * j]);
		}
	}

	min_mstacks = (MATCH *) ckalloc(num_seq * sizeof(MATCH));
	min_mscore = malign_band(seq, len_seq, num_seq, predstacks, num_predstacks, min_mstacks, score, num_seeds, min_perc,
			bandsize);
printf("min_mscore %f num_pair %d\n", min_mscore, min_mstacks[0].num_pair);

/*	Copy the stacks found in the 1st run	*/

	predstacks_fin = (int **) ckalloc(num_seq * sizeof(int *));
	score_fin = (double **) ckalloc(num_seq * sizeof(double *));
	for(i = 0; i < num_seq; i ++)	{
		predstacks_fin[i] = (int *) ckalloc(4 * MAX_LOOP * sizeof(int));
		score_fin[i] = (double *) ckalloc(MAX_LOOP * sizeof(double));
		for(m = 0; m < min_mstacks[i].num_pair; m ++)	{
			k = min_mstacks[i].pair[m * 2 + 1];
			if(k >= 0)	{
				for(j = 0; j < 4; j ++)	{
					predstacks_fin[i][4 * m + j] = predstacks[i][4 * k + j];
				}
				score_fin[i][m] = score[i][k];
			} else	{
				predstacks_fin[i][4 * m] = -1;
			}
		}
	}
	num_pair = min_mstacks[0].num_pair;

/*	Fill in missing stacks	*/

	indexi = -1;
	for(i = 0; i < num_seq; i ++)	{
		for(m = 0; m < min_mstacks[i].num_pair; m ++)	{
			k = min_mstacks[i].pair[m * 2 + 1];
			if(k < 0)	{
				break;
			}
		}
		if(m == min_mstacks[i].num_pair)	{
			indexi = i;
			break;
		}
	}

/*	Find stacks in the loops with loose condition */

	score_tmp1 = (double *) ckalloc(MAX_STACK * sizeof(double));
	score_tmp2 = (double *) ckalloc(MAX_STACK * sizeof(double));
	predstacks_tmp1 = (int *) ckalloc(4 * MAX_STACK * sizeof(int));
	predstacks_tmp2 = (int *) ckalloc(4 * MAX_STACK * sizeof(int));
	for(i = 0; i < num_seq; i ++)	{
		for(m = 0; m < min_mstacks[i].num_pair; m ++)	{
			k = min_mstacks[i].pair[m * 2 + 1];
			if(k < 0)	{
				break;
			}
		}
		if(m == min_mstacks[i].num_pair)	{
			continue;
		}
		num_predstacks_tmp2 = predict_stack(seq[i], len_seq[i], predstacks_tmp2, maxgap, min_hb3, min_sl3);
		for(j = 0; j < 4 * num_predstacks_tmp2; j ++)	{
			predstacks_tmp2[j] ++;
		}
		sortbpu(predstacks_tmp2, num_predstacks_tmp2);
		for(j = 0; j < num_predstacks_tmp2; j ++)	{
			score_tmp2[j] = compu_score(seq[i], len_seq[i], &predstacks_tmp2[4 * j]);
		}
		min_mstacks[i].num_pair = 0;
		alignRNAstacks_band(seq[indexi], len_seq[indexi], seq[i], len_seq[i],
				 predstacks_fin[indexi], num_pair,
				 predstacks_tmp2, num_predstacks_tmp2, score_fin[indexi],
				 score_tmp2, bandsize, &min_mstacks[i]);
		for(j = 0; j < min_mstacks[i].num_pair; j ++)	{
			m = min_mstacks[i].pair[j * 2];
			n = min_mstacks[i].pair[j * 2 + 1];
			for(k = 0; k < 4; k ++)	{
				predstacks_fin[i][4 * m + k] = predstacks_tmp2[4 * n + k];
			}
		}
	}
	for(i = 0; i < num_seq; i ++)	{
		free((void *) score_fin[i]);
	}
	free((void **) score_fin);
	free((void *) predstacks_tmp1);
	free((void *) predstacks_tmp2);
	free((void *) score_tmp1);
	free((void *) score_tmp2);

/*	Get loops	*/

	partialseq = (char **) ckalloc(num_seq * sizeof(char *));
	loops = (int *) ckalloc(MAX_LOOP * sizeof(int));
	len_loops = (int *) ckalloc(num_seq * sizeof(int));
	looppos = (int **) ckalloc(num_seq * sizeof(int *));
	num_pos = (int *) ckalloc(num_seq * sizeof(int));
	for(i = 0; i < num_seq; i ++)	{
		looppos[i] = (int *) ckalloc(MAX_LOOP * sizeof(int));
		partialseq[i] = (char *) ckalloc(len_seq[i] * sizeof(char));
	}
	num_loop = getloop(min_loop_len, min_all_loop_len, loops, predstacks_fin[indexi], num_pair, len_seq[indexi]);

/*	Run algorithm on the loops only	*/
	min_2mstacks = (MATCH *) ckalloc(num_seq * sizeof(MATCH));
	for(m = 0; m < num_loop; m ++)	{
		for(i = 0; i < num_seq; i ++)	{
			len_loops[i] = 0;
		}
		getpartialseq(partialseq, len_loops, predstacks_fin, seq, len_seq, num_seq, loops[m], looppos, num_pos,
			num_pair, indexi, min_loop_len);
		for(i = 0; i < num_seq; i ++)	{
			num_predstacks[i] = predict_stack(partialseq[i], len_loops[i], predstacks[i], maxgap, min_hb2, min_sl2);
/*	Filter loops crossing the boundaries	*/
			num_predstacks[i] = loopscreen(predstacks[i], num_predstacks[i], looppos[i], num_pos[i]);
			if(num_predstacks[i] == 0)	{
				break;
			}
			for(j = 0; j < 4 * num_predstacks[i]; j ++)	{
				predstacks[i][j] ++;
			}
			sortbpu(predstacks[i], num_predstacks[i]);
			for(j = 0; j < num_predstacks[i]; j ++)	{
				score[i][j] = compu_score(partialseq[i], len_loops[i], &predstacks[i][4 * j]);
			}
			printf("%d # stacks: %d length %d\n", i, num_predstacks[i], len_loops[i]);
		}
		if(i < num_seq)	{
			continue;
		}
		for(i = 0; i < num_seq; i ++)	{
			min_2mstacks[i].num_pair = 0;
		}
		ss = malign_band(partialseq, len_loops, num_seq, predstacks, num_predstacks, min_2mstacks, score, num_seeds, min_perc, bandsize);
printf("new pair %d %d min_mscore %f num_pair %d\n", loops[m], len_loops[0], ss, min_2mstacks[0].num_pair);

/*	Add new stacks	*/
		for(i = 0; i < num_seq; i ++)	{
			for(n = 0; n < min_2mstacks[i].num_pair; n ++)	{
				k = min_2mstacks[i].pair[n * 2 + 1];
				if(k >= 0)	{
					for(j = 0; j < 4; j ++)	{
/*	get the right positions of loops 	*/
						predstacks_fin[i][4 * (num_pair + n) + j] = transform_looppos(
						 predstacks[i][4 * k + j], looppos[i], num_pos[i]);
					}
				} else	{
					predstacks_fin[i][4 * (num_pair + n)] = -1;
				}
			}
		}
		num_pair += min_2mstacks[0].num_pair;
	}
	free((void *) min_2mstacks);
	free((void *) loops);
	free((void *) len_loops);
	for(i = 0; i < num_seq; i ++)	{
		free((void *) looppos[i]);
		free((void *) partialseq[i]);
	}
	free((void **) looppos);
	free((void *) num_pos);
	free((void **) partialseq);

/*	Sort stacks	*/
	index = (int *) ckalloc(num_pair * sizeof(int));
	for(i = 0; i < num_pair; i ++)	{
		index[i] = i;
	}
	for(i = 0; i < num_pair; i ++)	{
		for(j = i + 1; j < num_pair; j ++)	{
			if(predstacks_fin[0][4 * index[i]] > predstacks_fin[0][4 * index[j]])	{
				k = index[j];
				index[j] = index[i];
				index[i] = k;
			}
		}
	}

/*	output stacks	*/

	fp = ckopen(outfile, "w");
	for(i = 0; i < num_seq; i ++)	{
		fprintf(fp, "> ");
		for(m = 0; m < num_pair; m ++)	{
			k = index[m];
			if(predstacks_fin[i][4 * k] >= 0)	{
				fprintf(fp, "%d-%d,%d-%d ", predstacks_fin[i][4 * k], predstacks_fin[i][4 * k + 1],
					predstacks_fin[i][4 * k + 2], predstacks_fin[i][4 * k + 3]);
			} else	{
				fprintf(fp, "*,* ");
			}
		}
		fprintf(fp, "\n");
	}
	fclose(fp);
	printf("Score: %f num_pair %d\n", min_mscore, num_pair);
	free((void *) index);
	for(i = 0; i < num_seq; i ++)	{
		free((void *) predstacks_fin[i]);
	}
	free((void **) predstacks_fin);
	exit(0);

	n = 0;
	for(m = 0; m < ITERTIMES; m ++)	{
printf("m %d\n", m);
		permute_seq(seq, len_seq, num_seq);
		for(i = 0; i < num_seq; i ++)	{
		 	free((void *) score[i]);
			num_predstacks[i] = predict_stack(seq[i], len_seq[i], predstacks[i], maxgap, min_hb, min_sl);
			for(j = 0; j < 4 * num_predstacks[i]; j ++)	{
				predstacks[i][j] ++;
			}
			sortbpu(predstacks[i], num_predstacks[i]);
			score[i] = (double *) ckalloc(num_predstacks[i] * sizeof(double));
			for(j = 0; j < num_predstacks[i]; j ++)	{
				score[i][j] = compu_score(seq[i], len_seq[i], &predstacks[i][4 * j]);
			}
		}
/*
for(i = 0; i < num_seq; i ++)	{
	printf("> ");
	for(j = 0; j < num_predstacks[i]; j ++)	{
		printf("%d-%d,%d-%d ", predstacks[i][4 * j], predstacks[i][4 * j + 1],
			predstacks[i][4 * j + 2], predstacks[i][4 * j + 3]);
	}
	printf("\n");
}
for(i = 0; i < num_seq; i ++)	{
	printf(">i %d stacks %d %d\n", i, len_seq[i], num_predstacks[i]);
	for(j = 0; j < len_seq[i]; j ++)	{
		printf("%c", seq[i][j]);
		if(j % 60 == 59)	{
			printf("\n");
		}
	}
	if(j % 60 != 0)	{
		printf("\n");
	}
}
*/
		ss = malign_band(seq, len_seq, num_seq, predstacks, num_predstacks, min_mstacks, score, num_seeds, min_perc, bandsize);
printf("ss %f\n", ss);
		if(min_mscore < ss)	{
			n ++;
		}
	}
	printf("P-value: %f\n", ((double) n) / ITERTIMES);
	free((void *) min_mstacks);

	for(i = 0; i < num_seq; i ++)	{
		free((void *) predstacks[i]);
		free((void *) score[i]);
	}
	free((void **) score);
	free((void **) predstacks);
	free((void *) num_predstacks);
	for(i = 0; i < MAX_SEQ; i ++)	{
		free((void *) seq[i]);
		free((void *) seqname[i]);
	}
	free((void *) len_seq);
	free((void **) seq);
	free((void **) seqname);
}

void initenv(int argc, char **argv)
{
	int copt;
	int inpseq, outseq;	
	extern char *optarg;

	inpseq = outseq = 0;
	min_perc = 0.7;
	num_seeds = 100;
	weight1 = 0.1;
	weight2 = 0.03;
	maxgap = 0;
	min_sl = 4;
	min_hb = 8;
	min_sl2 = 3;
	min_hb2 = 6;
	min_sl3 = 3;
	min_hb3 = 6;
	min_loop_len = 12;
	min_all_loop_len = 20;
	gurem = 1;
	GAPST = 3;
	GAPET = 2;
	bandsize = 30;

	while ((copt=getopt(argc,argv,"i:o:n:g:m:b:s:h:B:H:pw:v:G:H:l:L:X:Y:")) != EOF)	{
		switch(copt) {
			case 'i':
			  inpseq = 1;
			  sscanf(optarg,"%s", inpfile);
			  continue;
			case 'g':
			  sscanf(optarg,"%d", &maxgap);
			  continue;
			case 'h':
			  sscanf(optarg,"%d", &min_hb);
			  continue;
			case 's':
			  sscanf(optarg,"%d", &min_sl);
			  continue;
			case 'B':
			  sscanf(optarg,"%d", &min_hb2);
			  continue;
			case 'S':
			  sscanf(optarg,"%d", &min_sl2);
			  continue;
			case 'X':
			  sscanf(optarg,"%d", &min_hb3);
			  continue;
			case 'Y':
			  sscanf(optarg,"%d", &min_sl3);
			  continue;
			case 'l':
			  sscanf(optarg,"%d", &min_loop_len);
			  continue;
			case 'L':
			  sscanf(optarg,"%d", &min_all_loop_len);
			  continue;
			case 'p':
			  gurem = 0;
			  continue;
			case 'n':
			  sscanf(optarg,"%d", &num_seeds);
			  continue;
			case 'm':
			  sscanf(optarg,"%lf", &min_perc);
			  continue;
			case 'w':
			  sscanf(optarg,"%lf", &weight1);
			  continue;
			case 'v':
			  sscanf(optarg,"%lf", &weight2);
			  continue;
			case 'G':
			  sscanf(optarg,"%d", &GAPST);
			  continue;
			case 'H':
			  sscanf(optarg,"%d", &GAPET);
			  continue;
			case 'b':
			  sscanf(optarg,"%d", &bandsize);
			  continue;
			case 'o':
			  outseq = 1;
			  sscanf(optarg,"%s", outfile);
			  continue;
			default:
			 printf("RNAscf -i InpFile -o outfile [-n num_seeds -g maxgap -h min_hb -s min_sl -p -m min_perc -w weight1 -v weight2 -G gapst -H gapet -b bandsize]\n");
			 printf("-i Inpfile: The input name of sequences\n");
			 printf("-o Outfile: The output file name of matched stacks\n");
			 printf("\n");
			 printf("-n num_seeds (optional): # seeds used for multiple alignment (default 100!)\n");
			 printf("-h min_hb: the minimum # hydrogen bonds for each stack (default 8)\n");
			 printf("-s min_sl: the minimum length for each stack (default 4)\n"); 
			 printf("-p : alowing g-u pair.\n");
			 printf("-m min_prec: the minimum percentage of stacks conserved in all sequences (0.7) \n");
			 printf("-w weight1 (optional): the weight for loop similarity (default 0.04)\n");
			 printf("-v weight2 (optional): the weight for stack similarity (default 0.02)\n");
			 printf("-G gapst (optional): open gap panelty (default 3)\n");
			 printf("-H gapet (optional): extension gap panelty (default 2)\n");
			 printf("-b bandsize (optional): size of the banded alignment (default 30)\n");
			 exit(-1);
		}
		optind--;
	}
	weight3 = 1 - weight1 - weight2;

	if(inpseq == 0 || outseq == 0)	{
		printf("RNAscf -i InpFile -o outfile [-n num_seeds -g maxgap -h min_hb -s min_sl -p -m min_perc -w weight1 -v weight2 -G gapst -H gapet -b bandsize]\n");
		printf("-i Inpfile: The input file of sequences\n");
		printf("-o Outfile: The output file name of matched stacks\n");
		printf("\n");
		printf("-n num_seeds (optional): # seeds used for multiple alignment (default 100!)\n");
		printf("-h min_hb: the minimum # hydrogen bonds for each stack (default 8)\n");
		printf("-s min_sl: the minimum length for each stack (default 4)\n");
		printf("-p : alowing g-u pair.\n");
		printf("-m min_prec: the minimum percentage of stacks conserved in all sequences (0.7) \n");
		printf("-w weight1 (optional): the weight for loop similarity (default 0.04)\n");
		printf("-v weight2 (optional): the weight for stack similarity (default 0.02)\n");
		printf("-G gapst (optional): open gap panelty (default 3)\n");
		printf("-H gapet (optional): extension gap panelty (default 2)\n");
		printf("-b bandsize (optional): size of the banded alignment (default 30)\n");
		exit(-1);
	}
}
