#include <stdinc.h>
#include <extvab.h>
#include <extfunc.h>

int getloop(int min_loop_len, int min_all_loop_len, int *loops, int *predstacks, int num_pair, int len_seq);
int get_nl(int last, int next, int *predstacks, int num_pair, int *lps, int nl);
int transform_looppos(int pos, int *looppos, int num_pos);
void getpartialseq(char **partialseq, int *len_partialseq, int **predstacks, char **seq, int *len_seq, int num_seq, int loop,
			 int **looppos, int *num_pos, int num_pair, int indexi, int min_loop_len);
int loopscreen(int *predstacks, int num_predstacks, int *looppos, int num_pos);
int get_outter(int *predstacks, int loop, int num_pair);
void copyseq(char *seq1, char *seq2, int len);

int getloop(int min_loop_len, int min_all_loop_len, int *loops, int *predstacks, int num_pair, int len_seq)
{
	int	i, j, k, l, m, n;
	int	*lps, nl, tl;
	int	num_loop;
	int	last, next;

	num_loop = 0;
	lps = (int *) ckalloc(2 * (num_pair + 1) * sizeof(int));
	for(i = 0; i < num_pair; i ++)	{
		nl = 0;
		nl = get_nl(predstacks[4 * i + 1] + 1, predstacks[4 * i + 2] - 1, predstacks, num_pair, lps, nl);
		tl = 0;
		for(j = 0; j < nl; j ++)	{
			l = lps[2 * j + 1] - lps[2 * j] + 1;
/*
			if(l < min_loop_len)	{
				break;
			}
*/
			tl += l;
		}
		if(j == nl && tl > min_all_loop_len)	{
			loops[num_loop ++] = i;
		}
	}
	nl = 0;
	nl = get_nl(1, len_seq, predstacks, num_pair, lps, nl);
	tl = 0;
	for(j = 0; j < nl; j ++)	{
		l = lps[2 * j + 1] - lps[2 * j] + 1;
/*
		if(l < min_loop_len)	{
			break;
		}
*/
		tl += l;
	}
	if(j == nl && tl > min_all_loop_len)	{
		loops[num_loop ++] = num_pair;
	}
	free((void *) lps);

	return(num_loop);
}

int get_nl(int last, int next, int *predstacks, int num_pair, int *lps, int nl)
{
	int	i, j, k, l;
	int	pos1, pos2;

	pos1 = pos2 = next;
	for(i = 0; i < num_pair; i ++)	{
		if(predstacks[4 * i] >= last && predstacks[4 * i + 3] <= next)	{
			if(predstacks[4 * i] - 1 < pos1)	{
				pos1 = predstacks[4 * i] - 1;
				pos2 = predstacks[4 * i + 3] + 1;
			}
		}
	}
	lps[2 * nl] = last;
	lps[2 * nl + 1] = pos1;
	nl ++;
	if(pos2 < next)	{
		nl = get_nl(pos2, next, predstacks, num_pair, lps, nl);
	}
	return(nl);
}

void getpartialseq(char **partialseq, int *len_partialseq, int **predstacks, char **seq, int *len_seq, int num_seq, int loop,
			 int **looppos, int *num_pos, int num_pair, int indexi, int min_loop_len)
{
	int	i, j, k, l, m, n;
	int	nl, *lps;
	int	last, next;
	int	new_loop;
	char	*label;

	lps = (int *) ckalloc(2 * (num_pair + 2) * sizeof(int));
	label = (char *) ckalloc((num_pair + 2) * sizeof(char));

	for(i = 0; i < num_seq; i ++)	{
		if(loop == num_pair)	{
			last = 1;
			next = len_seq[i];
		} else if(predstacks[4 * loop] < 0)	{
			new_loop = loop;
			while(new_loop >= 0 && predstacks[i][new_loop * 4] < 0)	{
				new_loop = get_outter(predstacks[indexi], new_loop, num_pair);
			}
			if(new_loop < 0)	{
				last = 1;
				next = len_seq[i];
			}
		} else	{
			last = predstacks[i][4 * loop + 1] + 1;
			next = predstacks[i][4 * loop + 2] - 1;
		}
		nl = 0;
		nl = get_nl(last, next, predstacks[i], num_pair, lps, nl);
		for(m = 0; m < nl; m ++)	{
			l = lps[2 * m + 1] - lps[2 * m] + 1;
			if(l < min_loop_len)	label[m] = 1;
		}
	}

	for(i = 0; i < num_seq; i ++)	{
		if(loop == num_pair)	{
			last = 1;
			next = len_seq[i];
		} else if(predstacks[4 * loop] < 0)	{
			new_loop = loop;
			while(new_loop >= 0 && predstacks[i][new_loop * 4] < 0)	{
				new_loop = get_outter(predstacks[indexi], new_loop, num_pair);
			}
			if(new_loop < 0)	{
				last = 1;
				next = len_seq[i];
			}
		} else	{
			last = predstacks[i][4 * loop + 1] + 1;
			next = predstacks[i][4 * loop + 2] - 1;
		}
		nl = 0;
		nl = get_nl(last, next, predstacks[i], num_pair, lps, nl);
		for(m = 0; m < nl; m ++)	{
			if(label[m] == 1)	continue;
			l = lps[2 * m + 1] - lps[2 * m] + 1;
			copyseq(&partialseq[i][len_partialseq[i]], &seq[i][lps[2 * m] - 1], l);
			looppos[i][2 * num_pos[i]] = len_partialseq[i];
			looppos[i][2 * num_pos[i] + 1] = lps[2 * m];
			len_partialseq[i] += l;
			num_pos[i] ++;
		}
		looppos[i][2 * num_pos[i]] = len_partialseq[i];
		num_pos[i] ++;
	}
	free((void *) label);
	free((void *) lps);
}

int get_outter(int *predstacks, int loop, int num_pair)
{
	int	i, j, k, l;
	int	pos;

	pos = 0;
	k = -1;
	for(i = 0; i < num_pair; i ++)	{
		if(predstacks[4 * i + 1] <= predstacks[4 * loop])	{
			if(predstacks[4 * i] > pos)	{
				k = i;
				pos = predstacks[4 * i];
			}
		}
	}
	return(k);
}

int loopscreen(int *predstacks, int num_predstacks, int *looppos, int num_pos)
{
	int	i, j, k, l;

	i = 0;
	while(i < num_predstacks)	{
		for(j = 0; j < num_pos; j ++)	{
			if(predstacks[4 * i] < looppos[2 * j] && predstacks[4 * i + 1] >= looppos[2 * j] ||
			   predstacks[4 * i + 2] < looppos[2 * j] && predstacks[4 * i + 3] >= looppos[2 * j])	{
				break;
			}
		}
		if(j < num_pos)	{
			num_predstacks --;
			for(k = 0; k < 4; k ++)	{
				predstacks[4 * i + k] = predstacks[4 * num_predstacks + k];
			}
		} else	{
			i ++;
		}
	}
	return(num_predstacks);
}

int transform_looppos(int pos, int *looppos, int num_pos)
{
	int	i, j, k, l;

	for(i = 0; i < num_pos - 1; i ++)	{
		if(pos > looppos[2 * i] && pos <= looppos[2 * i + 2])	{
			return(pos - looppos[2 * i] + looppos[2 * i + 1]);
		}
	}
	printf("Not found %d\n", pos);
}

void copyseq(char *seq1, char *seq2, int len)
{
	int	i;

	for(i = 0; i < len; i ++)	{
		seq1[i] = seq2[i];
	}
}
