#define MAX_PAIR 100
#define pow1(x) ((x) * (x))
#define rev(x) ((2 + (x)) % 4)
#define reverse_read(x, y) ((x) >= (y) ? (x - y) : (x + y))
#define max(x,y) ((x) > (y) ? (x) : (y))
#define min(x,y) ((x) < (y) ? (x) : (y))
#define numc(i, j) ((i) < (j)? (j)*((j)-1)/2+(i): (i)*((i)-1)/2+(j))
#define numl(i, j) ((i) < (j)? (j)*((j)+1)/2+(i): (i)*((i)+1)/2+(j))

typedef struct arc {
	char	name[100];
	int	num_seq;
	int	length;
	char	**aligned_seq;
	char	**seqname;
	char	*annotation;
} ARC;

typedef struct bpu {
	char	name[100];
	char	seqname[100];
	int	dist;
	char	seq1[100], seq2[100], alnstr[100];
} BPU;

typedef struct alnindex {
	int	posi, posj;
	int	score;
} ALNINDEX;

typedef struct index {
	int	pos;
	int	score;
	int 	score2;
} INDEX;

typedef struct bpupos {
	int	loop1[2], loop2[2];
	int	score;
	int	seqindex;
	int	stackindex;
	int	nums[2];
} BPUPOS;

typedef struct parascore {
	int	index1, index2;
	double	score;
	struct parascore *next;
} PARASCORE;

typedef struct stack {
	int	pos;
	struct stack *next;
} STACK;

typedef struct profile {
	int nuc_count[17];
	int tot_count;
} PROFILE;

typedef struct matchpair {
	int	pair[MAX_PAIR];
	int	num_pair;
	double	score;
	double	loopsim, stacksim, alleng;
} MATCH;

typedef struct line {
        int     bgnpoint[2];
        int     endpoint[2];
} LINE;
