#include <stdinc.h>
#include <extvab.h>
#include <extfunc.h>

double malign_band(char **seq, int *len_seq, int num_seq, int **predstacks, int *num_predstacks, MATCH *min_mstacks,
	      double **score, int num_seeds, double min_perc, int bandsize);

double malign_band(char **seq, int *len_seq, int num_seq, int **predstacks, int *num_predstacks, MATCH *min_mstacks,
	      double **score, int num_seeds, double min_perc, int bandsize)
{
	int	i, j, k, l, m, n, m1, m2;
	int	*predstacks_tmp, num_pair;
	int	*label;
	MATCH	*mstacks, match_stacks;
	double	min_mscore, ss, mscore, perc, *tmp_score;

	mstacks = (MATCH *) ckalloc(num_seq * sizeof(MATCH));
	min_mscore = 0;
	for(i = 0; i < num_seeds; i ++)	{
		m1 = ran_number(num_seq - 1, &idum);
		m2 = m1 + 1 + ran_number(num_seq - m1 - 1, &idum);
		match_stacks.num_pair = 0;
		mscore = alignRNAstacks_band(seq[m1], len_seq[m1], seq[m2], len_seq[m2], predstacks[m1],
			num_predstacks[m1], predstacks[m2], num_predstacks[m2], score[m1], score[m2], bandsize,
			&match_stacks);
		num_pair = match_stacks.num_pair;
		if(num_pair == 0)	continue;
		label = (int *) ckalloc(num_pair * sizeof(int));
		predstacks_tmp = (int *) ckalloc(4 * num_pair * sizeof(int));
		tmp_score = (double *) ckalloc(num_pair * sizeof(double));
		for(j = 0; j < num_pair; j ++)	{
			for(k = 0; k < 4; k ++)	{
				predstacks_tmp[4 * j + k] = predstacks[m1][4 * match_stacks.pair[2 * j] + k];
			}
			tmp_score[j] = score[m1][match_stacks.pair[2 * j]];
		}
		for(k = 0; k < num_pair; k ++)	{
			label[k] = 2;
		}
		for(j = 0; j < num_seq; j ++)	{
			if(j == m1)	{
				mstacks[j].num_pair = num_pair;
				for(k = 0; k < num_pair; k ++)	{
					mstacks[j].pair[2 * k] = k;
					mstacks[j].pair[2 * k + 1] = match_stacks.pair[2 * k];
				}
			} else if(j == m2)	{
				mstacks[j].num_pair = num_pair;
				for(k = 0; k < num_pair; k ++)	{
					mstacks[j].pair[2 * k] = k;
					mstacks[j].pair[2 * k + 1] = match_stacks.pair[2 * k + 1];
				}
			} else	{
				mstacks[j].num_pair = 0;
				ss = alignRNAstacks_band(seq[m1], len_seq[m1], seq[j], len_seq[j], predstacks_tmp,
					num_pair, predstacks[j], num_predstacks[j], tmp_score, score[j], bandsize,
					&mstacks[j]);
				mscore += ss;
				for(k = 0; k < mstacks[j].num_pair; k ++)	{
					label[mstacks[j].pair[2 * k]] ++;
				}
			}
		}
		mscore /= (num_seq - 1);
		if(mscore > min_mscore)	{
			min_mscore = mscore;
			for(j = 0; j < num_seq; j ++)	{
				m = 0;
				for(k = 0; k < num_pair; k ++)	{
					min_mstacks[j].pair[2 * k] = min_mstacks[j].pair[2 * k + 1] = -1;
				}
				for(k = 0; k < mstacks[j].num_pair; k ++)	{
					perc = ((double) label[mstacks[j].pair[2 * k]]) / num_seq;
					if(perc >= min_perc)	{
						min_mstacks[j].pair[2 * mstacks[j].pair[2 * k]] =
							match_stacks.pair[2 * mstacks[j].pair[2 * k]];
						min_mstacks[j].pair[2 * mstacks[j].pair[2 * k] + 1] =
							 mstacks[j].pair[2 * k + 1];
					}
				}
				min_mstacks[j].num_pair = num_pair;
			}
			n = 0;
			for(k = 0; k < num_pair; k ++)	{
				perc = ((double) label[k]) / num_seq;
				if(perc < min_perc)	continue;
				for(j = 0; j < num_seq; j ++)	{
					min_mstacks[j].pair[2 * n] = min_mstacks[j].pair[2 * k];
					min_mstacks[j].pair[2 * n + 1] = min_mstacks[j].pair[2 * k + 1];
				}
				n ++;
			}
			for(j = 0; j < num_seq; j ++)	{
				min_mstacks[j].num_pair = n;
			}
		}
		free((void *) predstacks_tmp);
		free((void *) tmp_score);
		free((void *) label);
	}
	free((void *) mstacks);
	return(min_mscore);
}
