#include <stdinc.h>
#include <extfunc.h>

int min_intv=3;
extern char gurem;

int predict_stack(char *seq, int length, int *stacks, int maxgap, int min_hb, int min_sl);
int trace_back(char *seq, int length, int maxgap, int **alnmat, int **scoremat, int **index, int mini, int minj, int *range,
	int score, int *num_match, int min_hb, int min_sl);
int indexcompar(ALNINDEX *a, ALNINDEX *b);

int predict_stack(char *seq, int length, int *stacks, int maxgap, int min_hb, int min_sl)
{
	int	i, j, k, l, m, n, q, c;
	int	**alnmat, **scoremat, **index;
	int	iend, jbeg;
	int	num_match;
	int	num_stack;
	int	range[4], alnl;
	ALNINDEX *alnindex;

	alnmat = (int **) ckalloc(length * sizeof(int *));
	scoremat = (int **) ckalloc(length * sizeof(int *));
	index = (int **) ckalloc(length * sizeof(int *));
	for(i = 0; i < length; i ++)	{
		alnmat[i] = (int *) ckalloc(length * sizeof(int));
		scoremat[i] = (int *) ckalloc(length * sizeof(int));
		index[i] = (int *) ckalloc(length * sizeof(int));
	}

	alnindex = (ALNINDEX *) ckalloc(length * (length + 1) / 2 * sizeof(ALNINDEX));
	n = 0;
	for(i = length - 1; i >= 0; i --)	{
		iend = min(length - 1, i + 1 + maxgap);
		for(j = i + 1; j < length; j ++)	{
			jbeg = max(0, j - 1 - maxgap);
			c = char2pair(seq[i], seq[j]);
/*	Mismatch = -3 hydrogen bond	*/
			if(c)	{
				scoremat[i][j] = 1;
			} else	{
				scoremat[i][j] = -3;
			}
			alnmat[i][j] = minmat(alnmat, scoremat, i + 1, iend, jbeg, j - 1);
			alnmat[i][j] += scoremat[i][j];
			if(alnmat[i][j] > 0 && scoremat[i][j] > 0 && i < j)	{
				alnindex[n].posi = i;
				alnindex[n].posj = j;
				alnindex[n].score = alnmat[i][j];
				n ++;
			}
		}
	}

	qsort((void *) alnindex, n, sizeof(ALNINDEX), (void *) indexcompar);
	for(m = 0; m < n; m ++)	{
		i = alnindex[m].posi;
		j = alnindex[m].posj;
		index[i][j] = m;
	}

	num_stack = 0;
	k = 0;
	while(k < n)	{
		i = alnindex[k].posi;
		j = alnindex[k].posj;
		if(index[i][j] < 0)	{
			k ++;
			continue;
		}
		alnl = trace_back(seq, length, maxgap, alnmat, scoremat, index, i, j, &stacks[4 * num_stack], alnmat[i][j],
			&num_match, min_hb, min_sl);
		if(alnl >= min_sl && num_match >= min_sl)	{
			for(m = stacks[4 * num_stack]; m <= stacks[4 * num_stack + 1]; m ++)	{
				index[m][stacks[4 * num_stack + 3] - m + stacks[4 * num_stack]] = -1;
			}
			num_stack ++;
		}
		k ++;
	}

	for(i = 0; i < length; i ++)	{
		free((void *) alnmat[i]);
		free((void *) scoremat[i]);
		free((void *) index[i]);
	}
	free((void **) alnmat);
	free((void **) scoremat);
	free((void **) index);
	free((void *) alnindex);
	return(num_stack);
}

int trace_back(char *seq, int length, int maxgap, int **alnmat, int **scoremat, int **index, int mini, int minj, int *range,
	int score, int *num_match, int min_hb, int min_sl)
{
	int	i, j, k, l, m, n, c, nhb;
	int	nexti, nextj;
	int	iend, jbeg;
	char	seq1[100], seq2[100];

/*	traceback	*/

	l = 0;
	nhb = 0;
	range[0] = mini;
	range[3] = minj;
	do	{
		seq1[l] = seq[mini];
		seq2[l] = seq[minj];
		l ++;
		c = char2pair(seq[mini], seq[minj]);
		if(c == 0)	{
			printf("Not match \n");
			exit(-1);
		}
		nhb += c;
		iend = min(length - 1, mini + 1 + maxgap);
		jbeg = max(0, minj - 1 - maxgap);
		score -= 1;
		if(score <= 0)	{
			break;
		}
		score = nextmat(alnmat, scoremat, mini + 1, iend, jbeg, minj - 1,
			score, &nexti, &nextj);
		mini ++;
		minj --;
		while(mini < nexti || minj > nextj)	{
			if(mini < nexti && minj > nextj)	{
				seq1[l] = seq[mini ++];
				seq2[l] = seq[minj --];
				l ++;
			} else if(mini == nexti)	{
				seq1[l] = '.';
				seq2[l] = seq[minj --];
				l ++;
			} else if(minj == nextj)	{
				seq1[l] = seq[mini ++];
				seq2[l] = '.';
				l ++;
			}
		}
	} while(score > 0);

	k = 0;
	for(i = 0; i < l; i ++)	{
		c = char2pair(seq1[i], seq2[i]);
		if(c)	{
			k ++;
		}
	}
	*num_match = k;

	overseq(seq1, l);
	overseq(seq2, l);
/*
	if(l >= 4)	{
		for(i = 0; i < l; i ++)	{
			printf("%c", seq1[i]);
		}
		printf("\n");
		for(i = 0; i < l; i ++)	{
			c = char2pair(seq1[i], seq2[i]);
			if(c)	{
				printf("|");
			} else	{
				printf(" ");
			}
		}
		printf("\n");
		for(i = 0; i < l; i ++)	{
			printf("%c", seq2[i]);
		}
		printf("\n");
	}
*/

	range[1] = mini;
	range[2] = minj;

/*	Remove the G-U pairs in the end of stacks	*/

	for(i = 0; i < l; i ++)	{
		c = char2pair(seq[range[0]], seq[range[3]]);
		if(c == 1 && gurem)	{
			range[0] ++;
			range[3] --;
			nhb --;
		} else	{
			break;
		}
	}
	for(i = 0; i < l; i ++)	{
		c = char2pair(seq[range[1]], seq[range[2]]);
		if(gurem && c == 1 || range[2] - range[1] <= min_intv)	{
			range[1] --;
			range[2] ++;
			nhb -= c;
		} else	{
			break;
		}
	}

	if(range[1] - range[0] < 0 || range[3] - range[2] < 0 || nhb < min_hb)	{
		return(0);
	} else	{
		return(l);
	}
}

int indexcompar(ALNINDEX *a, ALNINDEX *b)
{
	if(a -> score > b -> score || a -> score == b -> score && a -> posi > b -> posi ||
	   a -> score == b -> score && a -> posi == b -> posi && a -> posj < b -> posj)	 return(-1);
	else				 return(1);
}
