#include <stdinc.h>
#include <extfunc.h>

#define MAXNUM 100000

int readseqname(char **src_name, FILE *fp);
int readseqpar(int *max_leg, int *max_name_leg, FILE *fp);
int readseq1by1(char **src_seq, char **src_name, int *len_seq, FILE *fp);
int readseq1by1gen(char **src_seq, char **src_name, int *len_seq, FILE *fp);


int readseqname(char **src_name, FILE *fp)
{
	int	i, j, k, l, n;
	char	*seq, c;
	char	str[5000];

	k = 0;
	while(fgets(str, 4950, fp))	{
		if(str[0] == '>')	{
			sscanf(&str[1], "%s", src_name[k]);
			k ++;
		}
	}
	return(k);
}

int readseqpar(int *max_leg, int *max_name_leg, FILE *fp)
{
	int	i, j, k, l, n;
	char	*seq, c;
	char	str[5000], src_name[5000];

	*max_name_leg = *max_leg = 1;
	n = 0;
	k = -1;
	while(fgets(str, 4950, fp))	{
		if(str[0] == '>')	{
			if(k >= 0)	{
				if(n > *max_leg)	{
					*max_leg = n;
				}
			}
			n = 0;
			k ++;
			sscanf(&str[1], "%s", src_name);
			if((l = strlen(src_name)) > *max_name_leg)		*max_name_leg = l;
		} else {
			n += strlen(str);
		}
	}
	if(n > *max_leg)	{
		*max_leg = n;
	}
	k ++;
	return(k);
}

int readseq1by1(char **src_seq, char **src_name, int *len_seq, FILE *fp)
{
	int	i, j, k, l, n;
	char	*seq, c;
	char	str[5000];

	seq = (char *) ckalloc(MAXNUM * sizeof(char));

	n = 0;
	k = -1;
	while(fgets(str, 4950, fp))	{
		if(str[0] == '#')	continue;
		if(str[0] == '>')	{
			if(k >= 0)	{
				len_seq[k] = n;
				src_seq[k] = (char *) ckalloc((n + 1) * sizeof(char));
				for(i = 0; i < n; i ++)		src_seq[k][i] = seq[i];
			}
			n = 0;
			k ++;
			sscanf(&str[1], "%s", src_name[k]);
		} else {
			for(i = 0; i < strlen(str); i ++)	{
				if(str[i] >= 'a' && str[i] <= 'z') {
					c = str[i] - 'a' + 'A';
				} else if(str[i] >= 'A' && str[i] <= 'Z') {
					c = str[i];
				}
				if(c == 'T')	{
					c == 'U';
				}
				if(c >= 'A' && c <= 'Z')	{
					seq[n ++] = c;
				}
			}
		}
	}

	if(k >= 0)	{
		len_seq[k] = n;
		src_seq[k] = (char *) ckalloc((n + 1) * sizeof(char));
		for(i = 0; i < n; i ++)		src_seq[k][i] = seq[i];
	}
	k ++;

	free((void *) seq);
	return(k);
}

int readseq1by1gen(char **src_seq, char **src_name, int *len_seq, FILE *fp)
{
	int	i, j, k, l, n;
	char	*seq, c;
	char	str[500];

	seq = (char *) ckalloc(MAXNUM * sizeof(char));

	n = 0;
	k = -1;
	while(fgets(str, 450, fp))	{
		if(str[0] == '#')	continue;
		if(str[0] == '>')	{
			if(k >= 0)	{
				len_seq[k] = n;
				src_seq[k] = (char *) ckalloc((n + 1) * sizeof(char));
				for(i = 0; i < n; i ++)		src_seq[k][i] = seq[i];
			}
			n = 0;
			k ++;
			sscanf(&str[1], "%s", src_name[k]);
		} else {
			for(i = 0; i < strlen(str); i ++)	{
				if(str[i] >= 'a' && str[i] <= 'z') {
					c = str[i] - 'a' + 'A';
					seq[n ++] = c;
				} else if(str[i] >= 'A' && str[i] <= 'Z') {
					c = str[i];
					seq[n ++] = c;
				}
			}
		}
	}

	if(k >= 0)	{
		len_seq[k] = n;
		src_seq[k] = (char *) ckalloc((n + 1) * sizeof(char));
		for(i = 0; i < n; i ++)		src_seq[k][i] = seq[i];
	}
	k ++;

	free((void *) seq);
	return(k);
}
