#include <stdinc.h>
#include <score.h>
#include <extfunc.h>

#define MAX_SEQ 6000
#define MAX_REALSTACK 50
#define MAX_STACK 3500

char inpfile[100], seqfile[100], outfile[100];
int  maxgap;

void initenv(int argc, char **argv);

main(int argc, char **argv)
{
	int	i, j, k, l, m, n, p, q;
	int	*numcov;
	int	**stacks, **predstacks;
	int	*num_stacks, *num_predstacks;
	int	*len_seq, num_seq;
	MATCH	match_stacks;
	int	tot_num, tot_tru;
	char	**seq, **seqname;
	char	*sec_str;
	BPUPOS	*bpupos;
	FILE	*fp;

	initenv(argc, argv);

	len_seq = (int *) ckalloc(MAX_SEQ * sizeof(int));
	seq = (char **) ckalloc(MAX_SEQ * sizeof(char *));
	seqname = (char **) ckalloc(MAX_SEQ * sizeof(char *));
	for(i = 0; i < MAX_SEQ; i ++)	{
		seqname[i] = (char *) ckalloc(100 * sizeof(char));
	}
	fp = ckopen(seqfile, "r");
	num_seq = readseq1by1(seq, seqname, len_seq, fp);
	fclose(fp);
printf("num_seq = %d\n", num_seq);

	num_predstacks = (int *) ckalloc(num_seq * sizeof(int));
	predstacks = (int **) ckalloc(num_seq * sizeof(int *));
	for(i = 0; i < num_seq; i ++)	{
		predstacks[i] = (int *) ckalloc(4 * MAX_STACK * sizeof(int));
	}

	fp = ckopen(inpfile, "r");
	n = readbpu(predstacks, num_predstacks, fp);
	fclose(fp);
printf("num_seq = %d\n", n);

	if(n != num_seq)	{
		printf("Number not equal\n");
		exit(-1);
	}
	tot_num = 0;
	for(i = 0; i < num_seq; i ++)	{
		tot_num += num_predstacks[i];
	}
printf("tot %d\n", tot_num);

	for(i = 0; i < num_seq; i ++)	{
		sortbpu(predstacks[i], num_predstacks[i]);
	}

	fp = ckopen(outfile, "w");
	for(i = 0; i < num_seq; i ++)	{
		sec_str = (char *) ckalloc(len_seq[i] * sizeof(char));
		for(j = 0; j < len_seq[i]; j ++)	{
			sec_str[j] = '.';
		}
		for(j = 0; j < num_predstacks[i]; j ++)	{
			l = predstacks[i][4 * j + 1] - predstacks[i][4 * j];
			for(k = 0; k <= l; k ++)	{
				if(sec_str[predstacks[i][4 * j] + k - 1] == '.' && sec_str[predstacks[i][4 * j + 3] - k - 1] == '.') {
					sec_str[predstacks[i][4 * j] + k - 1] = '(';
					sec_str[predstacks[i][4 * j + 3] - k - 1] = ')';
				}
			}
		}
		for(j = 0; j < len_seq[i]; j ++)	{
			fprintf(fp, "%c", seq[i][j]);
		}
		fprintf(fp, "\n");
		for(j = 0; j < len_seq[i]; j ++)	{
			fprintf(fp, "%c", sec_str[j]);
		}
		fprintf(fp, "\n");
		free((void *) sec_str);
	}
	fclose(fp);

	for(i = 0; i < num_seq; i ++)	{
		free((void *) predstacks[i]);
	}
	free((void **) predstacks);
	free((void *) num_predstacks);
	for(i = 0; i < MAX_SEQ; i ++)	{
		free((void *) seq[i]);
		free((void *) seqname[i]);
	}
	free((void *) len_seq);
	free((void **) seq);
	free((void **) seqname);
}

void initenv(int argc, char **argv)
{
	int copt;
	int inpseq, outseq;	
	extern char *optarg;

	inpseq = outseq = 0;
	maxgap = 1;

	while ((copt=getopt(argc,argv,"i:o:s:")) != EOF)	{
		switch(copt) {
			case 'i':
			  inpseq = 1;
			  sscanf(optarg,"%s", inpfile);
			  continue;
			case 's':
			  sscanf(optarg,"%s", seqfile);
			  continue;
			case 'o':
			  outseq = 1;
			  sscanf(optarg,"%s", outfile);
			  continue;
			default:
			 printf("stack2struc -i InpFile -o outfile -s SeqFile\n");
			 printf("-i InpFile: The input file name of predicted stacks\n");
			 printf("-o Outfile: The output file name of matched stacks\n");
			 printf("-s Seqfile: The output file name of sequences\n");
			 exit(-1);
		}
		optind--;
	}

	if(inpseq == 0 || outseq == 0)	{
		printf("stack2struc -i InpFile -o outfile -s SeqFile\n");
		printf("-i InpFile: The input file name of predicted stacks\n");
		printf("-o Outfile: The output file name of matched stacks\n");
		printf("-s Seqfile: The output file name of sequences\n");
		exit(-1);
	}
}
